#!/usr/bin/env python2.7
# -*- coding: utf-8 -*-

import jsonmerge
import json
import sys
from pprint import pprint

if len(sys.argv) < 2:
	sys.exit(2)


base_file = sys.argv[1]
cc_file = sys.argv[2]

baseConfig = json.load(open(sys.argv[1]))
ccConfig = json.load(open(sys.argv[2]))

schema = {\
		"properties": {\
                 "objects": {\
					 "COMMENT": "managed.json",\
                     "type": "array",\
					 "mergeStrategy": "arrayMergeById",\
					 "mergeOptions": {"idRef": "name"}\
                 },\
				 "configs": {\
					 "mergeStrategy": "append"\
				 },\
				 "resources": {\
					 "COMMENT": "policy.json",\
					 "type": "array",\
					 "mergeStrategy": "arrayMergeById",\
					 "mergeOptions": {"idRef": "resource"},\
					 "properties": {
						 "properties": {\
							 "type": "array",\
							 "mergeStrategy": "arrayMergeById",\
							 "mergeOptions": {"idRef": "name"}\
						 }\
					 }
				 },\
				 "serverAuthContext": {\
					 "COMMENT": "authentication.json",\
					 "properties": {\
						 "authModules": {\
							 "type": "array",\
							 "mergeStrategy": "arrayMergeById",\
							 "mergeOptions": {"idRef": "name"}\
						 }\
					 }\
				 },\
				 "eventHandlers": {\
					 "COMMENT": "audit.json",\
					 "type": "array",\
					 "mergeStrategy": "arrayMergeById",\
					 "mergeOptions": {"idRef": "class"}\
				 }\
             }\
         }
         
finalConfig = jsonmerge.merge(baseConfig, ccConfig, schema)

#with open('resu.json', 'w') as outfile:
json.dump(finalConfig, sys.stdout, sort_keys=True, indent=2)