import org.forgerock.json.resource.NotSupportedException
import org.forgerock.json.resource.ReadRequest
import org.forgerock.json.resource.NotFoundException
import org.slf4j.*;
logger = LoggerFactory.getLogger('logger');

if (request instanceof ReadRequest) {

    login = request.additionalParameters.login;
    if (login == null) {
            throw new ResourceException(404, "Provide a login");
    }
    // query the system/computing account for login
    accounts = openidm.query("system/computing/account", ["_queryFilter" : "userName eq \"" + login + "\"", "validate": true], ["errors"]).result;
    
    logger.debug("accounts=" + accounts);
    if (accounts.size() == 0) {
            throw new ResourceException(404, "This login does not exist");
    }
    // do not handle if result.length > 1, it is not possible...
    return accounts[0];
} else {
    throw new NotSupportedException(request.getClass().getName());
}

